- Main Page
- Classes
- Files

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# moeoEasyEA< MOEOT > Class Template Reference

An easy class to design multi-objective evolutionary algorithms. More...

`#include <moeoEasyEA.h>`

Inheritance diagram for moeoEasyEA< MOEOT >:

List of all members.

## Public Member Functions
| moeoEasyEA (eoContinue< MOEOT > &_continuator, eoEvalFunc< MOEOT > &_eval, eoBreed< MOEOT > &_breed, moeoReplacement< MOEOT > &_replace, moeoFitnessAssignment< MOEOT > &_fitnessEval, moeoDiversityAssignment< MOEOT > &_diversityEval, bool _evalFitAndDivBeforeSelection=false)
| Ctor taking a breed and merge.
| moeoEasyEA (eoContinue< MOEOT > &_continuator, eoPopEvalFunc< MOEOT > &_popEval, eoBreed< MOEOT > &_breed, moeoReplacement< MOEOT > &_replace, moeoFitnessAssignment< MOEOT > &_fitnessEval, moeoDiversityAssignment< MOEOT > &_diversityEval, bool _evalFitAndDivBeforeSelection=false)
| Ctor taking a breed, a merge and a eoPopEval.
| moeoEasyEA (eoContinue< MOEOT > &_continuator, eoEvalFunc< MOEOT > &_eval, eoBreed< MOEOT > &_breed, eoMerge< MOEOT > &_merge, eoReduce< MOEOT > &_reduce, moeoFitnessAssignment< MOEOT > &_fitnessEval, moeoDiversityAssignment< MOEOT > &_diversityEval, bool _evalFitAndDivBeforeSelection=false)
| Ctor taking a breed, a merge and a reduce.
| moeoEasyEA (eoContinue< MOEOT > &_continuator, eoEvalFunc< MOEOT > &_eval, eoSelect< MOEOT > &_select, eoTransform< MOEOT > &_transform, moeoReplacement< MOEOT > &_replace, moeoFitnessAssignment< MOEOT > &_fitnessEval, moeoDiversityAssignment< MOEOT > &_diversityEval, bool _evalFitAndDivBeforeSelection=false)
| Ctor taking a select, a transform and a replacement.
| moeoEasyEA (eoContinue< MOEOT > &_continuator, eoEvalFunc< MOEOT > &_eval, eoSelect< MOEOT > &_select, eoTransform< MOEOT > &_transform, eoMerge< MOEOT > &_merge, eoReduce< MOEOT > &_reduce, moeoFitnessAssignment< MOEOT > &_fitnessEval, moeoDiversityAssignment< MOEOT > &_diversityEval, bool _evalFitAndDivBeforeSelection=false)
| Ctor taking a select, a transform, a merge and a reduce.
virtual void | operator() (eoPop< MOEOT > &_pop)
| Applies a few generation of evolution to the population _pop.
## Protected Attributes
eoContinue< MOEOT > & | continuator
| the stopping criteria
eoEvalFunc< MOEOT > & | eval
| the evaluation functions
eoPopLoopEval< MOEOT > | loopEval
| to evaluate the whole population
eoPopEvalFunc< MOEOT > & | popEval
| to evaluate the whole population
eoSelectTransform< MOEOT > | selectTransform
| breed: a select followed by a transform
eoBreed< MOEOT > & | breed
| the breeder
eoMergeReduce< MOEOT > | mergeReduce
| replacement: a merge followed by a reduce
moeoReplacement< MOEOT > & | replace
| the replacment strategy
moeoFitnessAssignment< MOEOT > & | fitnessEval
| the fitness assignment strategy
moeoDiversityAssignment< MOEOT > & | diversityEval
| the diversity assignment strategy
bool | evalFitAndDivBeforeSelection
| if this parameter is set to 'true', the fitness and the diversity of the whole population will be re-evaluated before the selection process
moeoEasyEA::eoDummyEval | dummyEval
| a dummy eval
moeoEasyEA::eoDummySelect | dummySelect
| a dummy select
moeoEasyEA::eoDummyTransform | dummyTransform
| a dummy transform
eoNoElitism< MOEOT > | dummyMerge
| a dummy merge
eoTruncate< MOEOT > | dummyReduce
| a dummy reduce
## Classes
class | eoDummyEval
| a dummy eval More...
class | eoDummySelect
| a dummy select More...
class | eoDummyTransform
| a dummy transform More...

## Detailed Description

### template<class MOEOT>
class moeoEasyEA< MOEOT >

An easy class to design multi-objective evolutionary algorithms.

Definition at line 33 of file moeoEasyEA.h.

## Constructor & Destructor Documentation

template<class MOEOT>

moeoEasyEA< MOEOT >::moeoEasyEA | ( | eoContinue< MOEOT > & | _continuator,
|  | eoEvalFunc< MOEOT > & | _eval,
|  | eoBreed< MOEOT > & | _breed,
|  | moeoReplacement< MOEOT > & | _replace,
|  | moeoFitnessAssignment< MOEOT > & | _fitnessEval,
|  | moeoDiversityAssignment< MOEOT > & | _diversityEval,
|  | bool | _evalFitAndDivBeforeSelection = `false` |
| ) |  |  | `[inline]`

Ctor taking a breed and merge.

Parameters:

  | _continuator | the stopping criteria
  | _eval | the evaluation functions
  | _breed | the breeder
  | _replace | the replacement strategy
  | _fitnessEval | the fitness evaluation scheme
  | _diversityEval | the diversity evaluation scheme
  | _evalFitAndDivBeforeSelection | put this parameter to 'true' if you want to re-evalue the fitness and the diversity of the population before the selection process

Definition at line 47 of file moeoEasyEA.h.

template<class MOEOT>

moeoEasyEA< MOEOT >::moeoEasyEA | ( | eoContinue< MOEOT > & | _continuator,
|  | eoPopEvalFunc< MOEOT > & | _popEval,
|  | eoBreed< MOEOT > & | _breed,
|  | moeoReplacement< MOEOT > & | _replace,
|  | moeoFitnessAssignment< MOEOT > & | _fitnessEval,
|  | moeoDiversityAssignment< MOEOT > & | _diversityEval,
|  | bool | _evalFitAndDivBeforeSelection = `false` |
| ) |  |  | `[inline]`

Ctor taking a breed, a merge and a eoPopEval.

Parameters:

  | _continuator | the stopping criteria
  | _popEval | the evaluation functions for the whole population
  | _breed | the breeder
  | _replace | the replacement strategy
  | _fitnessEval | the fitness evaluation scheme
  | _diversityEval | the diversity evaluation scheme
  | _evalFitAndDivBeforeSelection | put this parameter to 'true' if you want to re-evalue the fitness and the diversity of the population before the selection process

Definition at line 65 of file moeoEasyEA.h.

template<class MOEOT>

moeoEasyEA< MOEOT >::moeoEasyEA | ( | eoContinue< MOEOT > & | _continuator,
|  | eoEvalFunc< MOEOT > & | _eval,
|  | eoBreed< MOEOT > & | _breed,
|  | eoMerge< MOEOT > & | _merge,
|  | eoReduce< MOEOT > & | _reduce,
|  | moeoFitnessAssignment< MOEOT > & | _fitnessEval,
|  | moeoDiversityAssignment< MOEOT > & | _diversityEval,
|  | bool | _evalFitAndDivBeforeSelection = `false` |
| ) |  |  | `[inline]`

Ctor taking a breed, a merge and a reduce.

Parameters:

  | _continuator | the stopping criteria
  | _eval | the evaluation functions
  | _breed | the breeder
  | _merge | the merge scheme
  | _reduce | the reduce scheme
  | _fitnessEval | the fitness evaluation scheme
  | _diversityEval | the diversity evaluation scheme
  | _evalFitAndDivBeforeSelection | put this parameter to 'true' if you want to re-evalue the fitness and the diversity of the population before the selection process

Definition at line 84 of file moeoEasyEA.h.

template<class MOEOT>

moeoEasyEA< MOEOT >::moeoEasyEA | ( | eoContinue< MOEOT > & | _continuator,
|  | eoEvalFunc< MOEOT > & | _eval,
|  | eoSelect< MOEOT > & | _select,
|  | eoTransform< MOEOT > & | _transform,
|  | moeoReplacement< MOEOT > & | _replace,
|  | moeoFitnessAssignment< MOEOT > & | _fitnessEval,
|  | moeoDiversityAssignment< MOEOT > & | _diversityEval,
|  | bool | _evalFitAndDivBeforeSelection = `false` |
| ) |  |  | `[inline]`

Ctor taking a select, a transform and a replacement.

Parameters:

  | _continuator | the stopping criteria
  | _eval | the evaluation functions
  | _select | the selection scheme
  | _transform | the tranformation scheme
  | _replace | the replacement strategy
  | _fitnessEval | the fitness evaluation scheme
  | _diversityEval | the diversity evaluation scheme
  | _evalFitAndDivBeforeSelection | put this parameter to 'true' if you want to re-evalue the fitness and the diversity of the population before the selection process

Definition at line 103 of file moeoEasyEA.h.

template<class MOEOT>

moeoEasyEA< MOEOT >::moeoEasyEA | ( | eoContinue< MOEOT > & | _continuator,
|  | eoEvalFunc< MOEOT > & | _eval,
|  | eoSelect< MOEOT > & | _select,
|  | eoTransform< MOEOT > & | _transform,
|  | eoMerge< MOEOT > & | _merge,
|  | eoReduce< MOEOT > & | _reduce,
|  | moeoFitnessAssignment< MOEOT > & | _fitnessEval,
|  | moeoDiversityAssignment< MOEOT > & | _diversityEval,
|  | bool | _evalFitAndDivBeforeSelection = `false` |
| ) |  |  | `[inline]`

Ctor taking a select, a transform, a merge and a reduce.

Parameters:

  | _continuator | the stopping criteria
  | _eval | the evaluation functions
  | _select | the selection scheme
  | _transform | the tranformation scheme
  | _merge | the merge scheme
  | _reduce | the reduce scheme
  | _fitnessEval | the fitness evaluation scheme
  | _diversityEval | the diversity evaluation scheme
  | _evalFitAndDivBeforeSelection | put this parameter to 'true' if you want to re-evalue the fitness and the diversity of the population before the selection process

Definition at line 123 of file moeoEasyEA.h.

## Member Function Documentation

template<class MOEOT>

virtual void moeoEasyEA< MOEOT >::operator() | ( | eoPop< MOEOT > & | _pop | ) | `[inline, virtual]`

Applies a few generation of evolution to the population _pop.

Parameters:

  | _pop | the population

Definition at line 135 of file moeoEasyEA.h.

References moeoEasyEA< MOEOT >::breed, moeoEasyEA< MOEOT >::continuator, moeoEasyEA< MOEOT >::diversityEval, moeoEasyEA< MOEOT >::evalFitAndDivBeforeSelection, moeoEasyEA< MOEOT >::fitnessEval, moeoEasyEA< MOEOT >::popEval, and moeoEasyEA< MOEOT >::replace.

The documentation for this class was generated from the following file:

- moeoEasyEA.h